Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4502)
@@ -900,21 +908,21 @@
                       building = BTEST( wall_flags_total_0(k,j+1,i), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
+
                       unresolved_building = BTEST( wall_flags_total_0(k,j+1,i), 5 )  &
-                                     .AND.  BTEST( wall_flags_total_0(k,j+1,i), 6 ) 
-                                
+                                     .AND.  BTEST( wall_flags_total_0(k,j+1,i), 6 )
+
                       IF (  land_surface  .AND.  terrain  .AND.                &
                            .NOT. unresolved_building )  THEN
-                         num_lsm_v(1) = num_lsm_v(1) + 1 
+                         num_lsm_v(1) = num_lsm_v(1) + 1
                       ELSEIF ( urban_surface  .AND.  building )  THEN
-                         num_usm_v(1) = num_usm_v(1) + 1 
+                         num_usm_v(1) = num_usm_v(1) + 1
 !
 !--                   Default-surface type
                       ELSEIF ( .NOT. land_surface    .AND.                     &
                                .NOT. urban_surface )  THEN
-                         num_def_v(1) = num_def_v(1) + 1 
+                         num_def_v(1) = num_def_v(1) + 1
 !
 !--                   Unclassifified surface-grid point. Give error message.
-                      ELSE 
+                      ELSE
                          WRITE( message_string, * )                            &
                                           'Unclassified southward-facing ' //  &
@@ -934,21 +942,21 @@
                       building = BTEST( wall_flags_total_0(k,j,i-1), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
+
                       unresolved_building = BTEST( wall_flags_total_0(k,j,i-1), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j,i-1), 6 )
-                                     
+
                       IF (  land_surface  .AND.  terrain  .AND.                &
                            .NOT. unresolved_building )  THEN
-                         num_lsm_v(2) = num_lsm_v(2) + 1 
+                         num_lsm_v(2) = num_lsm_v(2) + 1
                       ELSEIF ( urban_surface  .AND.  building )  THEN
-                         num_usm_v(2) = num_usm_v(2) + 1 
+                         num_usm_v(2) = num_usm_v(2) + 1
 !
 !--                   Default-surface type
                       ELSEIF ( .NOT. land_surface    .AND.                     &
                                .NOT. urban_surface )  THEN
-                         num_def_v(2) = num_def_v(2) + 1 
+                         num_def_v(2) = num_def_v(2) + 1
 !
 !--                   Unclassifified surface-grid point. Give error message.
-                      ELSE 
+                      ELSE
                          WRITE( message_string, * )                            &
                                           'Unclassified eastward-facing ' //   &
@@ -968,21 +976,21 @@
                       building = BTEST( wall_flags_total_0(k,j,i+1), 6 )  .OR.       &
                                  topo_no_distinct
-                                 
+
                       unresolved_building = BTEST( wall_flags_total_0(k,j,i+1), 5 )  &
                                      .AND.  BTEST( wall_flags_total_0(k,j,i+1), 6 )
-                                 
+
                       IF (  land_surface  .AND.  terrain  .AND.                &
                            .NOT. unresolved_building )  THEN
-                         num_lsm_v(3) = num_lsm_v(3) + 1 
+                         num_lsm_v(3) = num_lsm_v(3) + 1
                       ELSEIF ( urban_surface  .AND.  building )  THEN
-                         num_usm_v(3) = num_usm_v(3) + 1 
+                         num_usm_v(3) = num_usm_v(3) + 1
 !
 !--                   Default-surface type
                       ELSEIF ( .NOT. land_surface    .AND.                     &
                                .NOT. urban_surface )  THEN
-                         num_def_v(3) = num_def_v(3) + 1 
+                         num_def_v(3) = num_def_v(3) + 1
 !
 !--                   Unclassifified surface-grid point. Give error message.
-                      ELSE 
+                      ELSE
                          WRITE( message_string, * )                            &
                                           'Unclassified westward-facing ' //   &
@@ -1010,8 +1018,8 @@
 !
 !--    Horizontal surface, natural type, so far only upward-facing
-       surf_lsm_h%ns    = num_lsm_h  
+       surf_lsm_h%ns    = num_lsm_h
 !
 !--    Horizontal surface, urban type, so far only upward-facing
-       surf_usm_h%ns    = num_usm_h    
+       surf_usm_h%ns    = num_usm_h
 !
 !--    Vertical surface, default type, northward facing
@@ -1051,5 +1059,5 @@
        surf_usm_v(3)%ns = num_usm_v(3)
 !
-!--    Allocate required attributes for horizontal surfaces - default type. 
+!--    Allocate required attributes for horizontal surfaces - default type.
 !--    Upward-facing (l=0) and downward-facing (l=1).
        DO  l = 0, 1
@@ -1060,12 +1068,12 @@
        CALL allocate_surface_attributes_h_top ( surf_def_h(2), nys, nyn, nxl, nxr )
 !
-!--    Allocate required attributes for horizontal surfaces - natural type. 
+!--    Allocate required attributes for horizontal surfaces - natural type.
        CALL allocate_surface_attributes_h ( surf_lsm_h, nys, nyn, nxl, nxr )
 !
-!--    Allocate required attributes for horizontal surfaces - urban type. 
+!--    Allocate required attributes for horizontal surfaces - urban type.
        CALL allocate_surface_attributes_h ( surf_usm_h, nys, nyn, nxl, nxr )
 
 !
-!--    Allocate required attributes for vertical surfaces. 
+!--    Allocate required attributes for vertical surfaces.
 !--    Northward-facing (l=0), southward-facing (l=1), eastward-facing (l=2)
 !--    and westward-facing (l=3).
@@ -1101,5 +1109,5 @@
 #endif
        IF ( num_surf_v > 0 )  vertical_surfaces_exist = .TRUE.
-        
+
 
     END SUBROUTINE init_surface_arrays
@@ -1117,5 +1125,5 @@
 
        INTEGER(iwp) ::  l     !<
-       
+
        !$ACC ENTER DATA &
        !$ACC COPYIN(surf_def_h(0:2)) &
@@ -1162,5 +1170,5 @@
 
        INTEGER(iwp) ::  l     !<
-       
+
        ! Delete data in surf_def_h(0:2)
        DO  l = 0, 1
@@ -1199,6 +1207,6 @@
 ! Description:
 ! ------------
-!> Deallocating memory for upward and downward-facing horizontal surface types, 
-!> except for top fluxes. 
+!> Deallocating memory for upward and downward-facing horizontal surface types,
+!> except for top fluxes.
 !------------------------------------------------------------------------------!
     SUBROUTINE deallocate_surface_attributes_h( surfaces )
@@ -1242,39 +1250,39 @@
 !
 !--    Vertical momentum fluxes of u and v
-       DEALLOCATE ( surfaces%usws )  
-       DEALLOCATE ( surfaces%vsws )  
+       DEALLOCATE ( surfaces%usws )
+       DEALLOCATE ( surfaces%vsws )
 !
 !--    Required in production_e
-       IF ( .NOT. constant_diffusion )  THEN    
-          DEALLOCATE ( surfaces%u_0 )  
+       IF ( .NOT. constant_diffusion )  THEN
+          DEALLOCATE ( surfaces%u_0 )
           DEALLOCATE ( surfaces%v_0 )
-       ENDIF 
+       ENDIF
 !
 !--    Characteristic temperature and surface flux of sensible heat
-       DEALLOCATE ( surfaces%ts )    
+       DEALLOCATE ( surfaces%ts )
        DEALLOCATE ( surfaces%shf )
 !
 !--    surface temperature
-       DEALLOCATE ( surfaces%pt_surface ) 
+       DEALLOCATE ( surfaces%pt_surface )
 !
 !--    Characteristic humidity and surface flux of latent heat
-       IF ( humidity )  THEN          
-          DEALLOCATE ( surfaces%qs ) 
-          DEALLOCATE ( surfaces%qsws )  
+       IF ( humidity )  THEN
+          DEALLOCATE ( surfaces%qs )
+          DEALLOCATE ( surfaces%qsws )
           DEALLOCATE ( surfaces%q_surface   )
           DEALLOCATE ( surfaces%vpt_surface )
-       ENDIF 
+       ENDIF
 !
 !--    Characteristic scalar and surface flux of scalar
        IF ( passive_scalar )  THEN
-          DEALLOCATE ( surfaces%ss )   
-          DEALLOCATE ( surfaces%ssws ) 
-       ENDIF 
+          DEALLOCATE ( surfaces%ss )
+          DEALLOCATE ( surfaces%ssws )
+       ENDIF
 !
 !--    Scaling parameter (cs*) and surface flux of chemical species
        IF ( air_chemistry )  THEN
-          DEALLOCATE ( surfaces%css )   
-          DEALLOCATE ( surfaces%cssws ) 
-       ENDIF 
+          DEALLOCATE ( surfaces%css )
+          DEALLOCATE ( surfaces%cssws )
+       ENDIF
 !
 !--    Arrays for storing potential temperature and
@@ -1283,7 +1291,7 @@
        DEALLOCATE ( surfaces%qv1 )
        DEALLOCATE ( surfaces%vpt1 )
-       
-!
-!--       
+
+!
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           DEALLOCATE ( surfaces%qcs )
@@ -1293,5 +1301,5 @@
        ENDIF
 !
-!--       
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           DEALLOCATE ( surfaces%qrs )
@@ -1301,4 +1309,12 @@
        ENDIF
 !
+!--
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+          DEALLOCATE ( surfaces%qis )
+          DEALLOCATE ( surfaces%nis )
+          DEALLOCATE ( surfaces%qisws )
+          DEALLOCATE ( surfaces%nisws )
+       ENDIF
+!
 !--    Salinity surface flux
        IF ( ocean_mode )  DEALLOCATE ( surfaces%sasws )
@@ -1310,6 +1326,6 @@
 ! Description:
 ! ------------
-!> Allocating memory for upward and downward-facing horizontal surface types, 
-!> except for top fluxes. 
+!> Allocating memory for upward and downward-facing horizontal surface types,
+!> except for top fluxes.
 !------------------------------------------------------------------------------!
     SUBROUTINE allocate_surface_attributes_h( surfaces,                        &
@@ -1326,8 +1342,8 @@
 
 !
-!--    Allocate arrays for start and end index of horizontal surface type 
+!--    Allocate arrays for start and end index of horizontal surface type
 !--    for each (j,i)-grid point. This is required e.g. in diffion_x, which is
-!--    called for each (j,i). In order to find the location where the 
-!--    respective flux is store within the surface-type, start- and end- 
+!--    called for each (j,i). In order to find the location where the
+!--    respective flux is store within the surface-type, start- and end-
 !--    index are stored for each (j,i). For example, each (j,i) can have
 !--    several entries where fluxes for horizontal surfaces might be stored,
@@ -1370,40 +1386,40 @@
 !
 !--    Vertical momentum fluxes of u and v
-       ALLOCATE ( surfaces%usws(1:surfaces%ns) )  
-       ALLOCATE ( surfaces%vsws(1:surfaces%ns) )  
+       ALLOCATE ( surfaces%usws(1:surfaces%ns) )
+       ALLOCATE ( surfaces%vsws(1:surfaces%ns) )
 !
 !--    Required in production_e
-       IF ( .NOT. constant_diffusion )  THEN    
-          ALLOCATE ( surfaces%u_0(1:surfaces%ns) )  
+       IF ( .NOT. constant_diffusion )  THEN
+          ALLOCATE ( surfaces%u_0(1:surfaces%ns) )
           ALLOCATE ( surfaces%v_0(1:surfaces%ns) )
-       ENDIF 
+       ENDIF
 !
 !--    Characteristic temperature and surface flux of sensible heat
-       ALLOCATE ( surfaces%ts(1:surfaces%ns)  )    
+       ALLOCATE ( surfaces%ts(1:surfaces%ns)  )
        ALLOCATE ( surfaces%shf(1:surfaces%ns) )
 !
 !--    Surface temperature
-       ALLOCATE ( surfaces%pt_surface(1:surfaces%ns) ) 
+       ALLOCATE ( surfaces%pt_surface(1:surfaces%ns) )
 !
 !--    Characteristic humidity, surface flux of latent heat, and surface virtual potential temperature
        IF ( humidity )  THEN
-          ALLOCATE ( surfaces%qs(1:surfaces%ns)   ) 
-          ALLOCATE ( surfaces%qsws(1:surfaces%ns) )      
-          ALLOCATE ( surfaces%q_surface(1:surfaces%ns)   ) 
-          ALLOCATE ( surfaces%vpt_surface(1:surfaces%ns) ) 
-       ENDIF 
+          ALLOCATE ( surfaces%qs(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%qsws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%q_surface(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%vpt_surface(1:surfaces%ns) )
+       ENDIF
 
 !
 !--    Characteristic scalar and surface flux of scalar
        IF ( passive_scalar )  THEN
-          ALLOCATE ( surfaces%ss(1:surfaces%ns)   )   
-          ALLOCATE ( surfaces%ssws(1:surfaces%ns) ) 
-       ENDIF 
+          ALLOCATE ( surfaces%ss(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%ssws(1:surfaces%ns) )
+       ENDIF
 !
 !--    Scaling parameter (cs*) and surface flux of chemical species
        IF ( air_chemistry )  THEN
-          ALLOCATE ( surfaces%css(1:nvar,1:surfaces%ns)   )   
-          ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) ) 
-       ENDIF 
+          ALLOCATE ( surfaces%css(1:nvar,1:surfaces%ns)   )
+          ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) )
+       ENDIF
 !
 !--    Arrays for storing potential temperature and
@@ -1413,5 +1429,5 @@
        ALLOCATE ( surfaces%vpt1(1:surfaces%ns) )
 !
-!--       
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           ALLOCATE ( surfaces%qcs(1:surfaces%ns)   )
@@ -1421,5 +1437,5 @@
        ENDIF
 !
-!--       
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qrs(1:surfaces%ns)   )
@@ -1428,4 +1444,14 @@
           ALLOCATE ( surfaces%nrsws(1:surfaces%ns) )
        ENDIF
+
+!
+!--
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+          ALLOCATE ( surfaces%qis(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%nis(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%qisws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%nisws(1:surfaces%ns) )
+       ENDIF
+
 !
 !--    Salinity surface flux
@@ -1445,7 +1471,7 @@
 
        IMPLICIT NONE
-   
+
        TYPE(surf_type) ::  surfaces  !< respective surface type
-   
+
        !$ACC EXIT DATA &
        !$ACC DELETE(surfaces%start_index(nys:nyn,nxl:nxr)) &
@@ -1473,5 +1499,5 @@
           !$ACC DELETE(surfaces%v_0(1:surfaces%ns))
        ENDIF
-   
+
     END SUBROUTINE exit_surface_attributes_h
 #endif
@@ -1522,5 +1548,5 @@
 ! Description:
 ! ------------
-!> Deallocating memory for model-top fluxes  
+!> Deallocating memory for model-top fluxes
 !------------------------------------------------------------------------------!
     SUBROUTINE deallocate_surface_attributes_h_top( surfaces )
@@ -1539,12 +1565,12 @@
        DEALLOCATE ( surfaces%k )
 
-       IF ( .NOT. constant_diffusion )  THEN    
-          DEALLOCATE ( surfaces%u_0 )  
+       IF ( .NOT. constant_diffusion )  THEN
+          DEALLOCATE ( surfaces%u_0 )
           DEALLOCATE ( surfaces%v_0 )
-       ENDIF 
+       ENDIF
 !
 !--    Vertical momentum fluxes of u and v
-       DEALLOCATE ( surfaces%usws )  
-       DEALLOCATE ( surfaces%vsws )  
+       DEALLOCATE ( surfaces%usws )
+       DEALLOCATE ( surfaces%vsws )
 !
 !--    Sensible heat flux
@@ -1553,18 +1579,18 @@
 !--    Latent heat flux
        IF ( humidity .OR. coupling_mode == 'ocean_to_atmosphere')  THEN
-          DEALLOCATE ( surfaces%qsws )      
-       ENDIF 
+          DEALLOCATE ( surfaces%qsws )
+       ENDIF
 !
 !--    Scalar flux
        IF ( passive_scalar )  THEN
-          DEALLOCATE ( surfaces%ssws ) 
-       ENDIF 
+          DEALLOCATE ( surfaces%ssws )
+       ENDIF
 !
 !--    Chemical species flux
        IF ( air_chemistry )  THEN
-          DEALLOCATE ( surfaces%cssws ) 
-       ENDIF 
-!
-!--       
+          DEALLOCATE ( surfaces%cssws )
+       ENDIF
+!
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           DEALLOCATE ( surfaces%qcsws )
@@ -1572,9 +1598,16 @@
        ENDIF
 !
-!--       
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           DEALLOCATE ( surfaces%qrsws )
           DEALLOCATE ( surfaces%nrsws )
        ENDIF
+
+!
+!--
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+          DEALLOCATE ( surfaces%qisws )
+          DEALLOCATE ( surfaces%nisws )
+       ENDIF
 !
 !--    Salinity flux
@@ -1587,5 +1620,5 @@
 ! Description:
 ! ------------
-!> Allocating memory for model-top fluxes  
+!> Allocating memory for model-top fluxes
 !------------------------------------------------------------------------------!
     SUBROUTINE allocate_surface_attributes_h_top( surfaces,                    &
@@ -1611,12 +1644,12 @@
        ALLOCATE ( surfaces%k(1:surfaces%ns)  )
 
-       IF ( .NOT. constant_diffusion )  THEN    
-          ALLOCATE ( surfaces%u_0(1:surfaces%ns) )  
+       IF ( .NOT. constant_diffusion )  THEN
+          ALLOCATE ( surfaces%u_0(1:surfaces%ns) )
           ALLOCATE ( surfaces%v_0(1:surfaces%ns) )
-       ENDIF 
+       ENDIF
 !
 !--    Vertical momentum fluxes of u and v
-       ALLOCATE ( surfaces%usws(1:surfaces%ns) )  
-       ALLOCATE ( surfaces%vsws(1:surfaces%ns) )  
+       ALLOCATE ( surfaces%usws(1:surfaces%ns) )
+       ALLOCATE ( surfaces%vsws(1:surfaces%ns) )
 !
 !--    Sensible heat flux
@@ -1625,18 +1658,18 @@
 !--    Latent heat flux
        IF ( humidity .OR. coupling_mode == 'ocean_to_atmosphere')  THEN
-          ALLOCATE ( surfaces%qsws(1:surfaces%ns) )      
-       ENDIF 
+          ALLOCATE ( surfaces%qsws(1:surfaces%ns) )
+       ENDIF
 !
 !--    Scalar flux
        IF ( passive_scalar )  THEN
-          ALLOCATE ( surfaces%ssws(1:surfaces%ns) ) 
-       ENDIF 
+          ALLOCATE ( surfaces%ssws(1:surfaces%ns) )
+       ENDIF
 !
 !--    Chemical species flux
        IF ( air_chemistry )  THEN
-          ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) ) 
-       ENDIF 
-!
-!--       
+          ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) )
+       ENDIF
+!
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_morrison)  THEN
           ALLOCATE ( surfaces%qcsws(1:surfaces%ns) )
@@ -1644,8 +1677,15 @@
        ENDIF
 !
-!--       
+!--
        IF ( surf_bulk_cloud_model .AND. surf_microphysics_seifert)  THEN
           ALLOCATE ( surfaces%qrsws(1:surfaces%ns) )
           ALLOCATE ( surfaces%nrsws(1:surfaces%ns) )
+       ENDIF
+
+!
+!--
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+          ALLOCATE ( surfaces%qisws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%nisws(1:surfaces%ns) )
        ENDIF
 !
@@ -1665,7 +1705,7 @@
 
        IMPLICIT NONE
-   
+
        TYPE(surf_type) ::  surfaces  !< respective surface type
-   
+
        !$ACC EXIT DATA &
        !$ACC DELETE(surfaces%start_index(nys:nyn,nxl:nxr)) &
@@ -1683,5 +1723,5 @@
           !$ACC DELETE(surfaces%v_0(1:surfaces%ns))
        ENDIF
-   
+
     END SUBROUTINE exit_surface_attributes_h_top
 #endif
@@ -1721,5 +1761,5 @@
 ! Description:
 ! ------------
-!> Deallocating memory for vertical surface types. 
+!> Deallocating memory for vertical surface types.
 !------------------------------------------------------------------------------!
     SUBROUTINE deallocate_surface_attributes_v( surfaces )
@@ -1731,12 +1771,12 @@
 
 !
-!--    Allocate arrays for start and end index of vertical surface type 
+!--    Allocate arrays for start and end index of vertical surface type
 !--    for each (j,i)-grid point. This is required in diffion_x, which is
-!--    called for each (j,i). In order to find the location where the 
-!--    respective flux is store within the surface-type, start- and end- 
+!--    called for each (j,i). In order to find the location where the
+!--    respective flux is store within the surface-type, start- and end-
 !--    index are stored for each (j,i). For example, each (j,i) can have
-!--    several entries where fluxes for vertical surfaces might be stored.  
-!--    In the flat case, where no vertical walls exit, set indicies such 
-!--    that loop in diffusion routines will not be entered. 
+!--    several entries where fluxes for vertical surfaces might be stored.
+!--    In the flat case, where no vertical walls exit, set indicies such
+!--    that loop in diffusion routines will not be entered.
        DEALLOCATE ( surfaces%start_index )
        DEALLOCATE ( surfaces%end_index )
@@ -1766,47 +1806,47 @@
 !
 !--    Allocate Obukhov length and bulk Richardson number. Actually, at
-!--    vertical surfaces these are only required for natural surfaces.  
+!--    vertical surfaces these are only required for natural surfaces.
 !--    for natural land surfaces
-       DEALLOCATE( surfaces%ol ) 
-       DEALLOCATE( surfaces%rib ) 
-!
-!--    Allocate arrays for surface momentum fluxes for u and v. For u at north- 
+       DEALLOCATE( surfaces%ol )
+       DEALLOCATE( surfaces%rib )
+!
+!--    Allocate arrays for surface momentum fluxes for u and v. For u at north-
 !--    and south-facing surfaces, for v at east- and west-facing surfaces.
        DEALLOCATE ( surfaces%mom_flux_uv )
 !
 !--    Allocate array for surface momentum flux for w - wsus and wsvs
-       DEALLOCATE ( surfaces%mom_flux_w ) 
-!
-!--    Allocate array for surface momentum flux for subgrid-scale tke wsus and 
+       DEALLOCATE ( surfaces%mom_flux_w )
+!
+!--    Allocate array for surface momentum flux for subgrid-scale tke wsus and
 !--    wsvs; first index usvs or vsws, second index for wsus or wsvs, depending
 !--    on surface.
-       DEALLOCATE ( surfaces%mom_flux_tke )  
+       DEALLOCATE ( surfaces%mom_flux_tke )
 !
 !--    Characteristic temperature and surface flux of sensible heat
-       DEALLOCATE ( surfaces%ts )    
+       DEALLOCATE ( surfaces%ts )
        DEALLOCATE ( surfaces%shf )
 !
 !--    surface temperature
-       DEALLOCATE ( surfaces%pt_surface ) 
+       DEALLOCATE ( surfaces%pt_surface )
 !
 !--    Characteristic humidity and surface flux of latent heat
        IF ( humidity )  THEN
-          DEALLOCATE ( surfaces%qs ) 
-          DEALLOCATE ( surfaces%qsws )  
+          DEALLOCATE ( surfaces%qs )
+          DEALLOCATE ( surfaces%qsws )
           DEALLOCATE ( surfaces%q_surface   )
           DEALLOCATE ( surfaces%vpt_surface )
-       ENDIF 
+       ENDIF
 !
 !--    Characteristic scalar and surface flux of scalar
        IF ( passive_scalar )  THEN
-          DEALLOCATE ( surfaces%ss )   
-          DEALLOCATE ( surfaces%ssws ) 
+          DEALLOCATE ( surfaces%ss )
+          DEALLOCATE ( surfaces%ssws )
        ENDIF
 !
 !--    Scaling parameter (cs*) and surface flux of chemical species
        IF ( air_chemistry )  THEN
-             DEALLOCATE ( surfaces%css )   
-             DEALLOCATE ( surfaces%cssws ) 
-       ENDIF 
+             DEALLOCATE ( surfaces%css )
+             DEALLOCATE ( surfaces%cssws )
+       ENDIF
 !
 !--    Arrays for storing potential temperature and
@@ -1829,4 +1869,12 @@
           DEALLOCATE ( surfaces%nrsws )
        ENDIF
+
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+          DEALLOCATE ( surfaces%qis )
+          DEALLOCATE ( surfaces%nis )
+          DEALLOCATE ( surfaces%qisws )
+          DEALLOCATE ( surfaces%nisws )
+       ENDIF
+
 !
 !--    Salinity surface flux
@@ -1839,5 +1887,5 @@
 ! Description:
 ! ------------
-!> Allocating memory for vertical surface types. 
+!> Allocating memory for vertical surface types.
 !------------------------------------------------------------------------------!
     SUBROUTINE allocate_surface_attributes_v( surfaces,                        &
@@ -1854,12 +1902,12 @@
 
 !
-!--    Allocate arrays for start and end index of vertical surface type 
+!--    Allocate arrays for start and end index of vertical surface type
 !--    for each (j,i)-grid point. This is required in diffion_x, which is
-!--    called for each (j,i). In order to find the location where the 
-!--    respective flux is store within the surface-type, start- and end- 
+!--    called for each (j,i). In order to find the location where the
+!--    respective flux is store within the surface-type, start- and end-
 !--    index are stored for each (j,i). For example, each (j,i) can have
-!--    several entries where fluxes for vertical surfaces might be stored.  
-!--    In the flat case, where no vertical walls exit, set indicies such 
-!--    that loop in diffusion routines will not be entered. 
+!--    several entries where fluxes for vertical surfaces might be stored.
+!--    In the flat case, where no vertical walls exit, set indicies such
+!--    that loop in diffusion routines will not be entered.
        ALLOCATE ( surfaces%start_index(nys_l:nyn_l,nxl_l:nxr_l) )
        ALLOCATE ( surfaces%end_index(nys_l:nyn_l,nxl_l:nxr_l)   )
@@ -1891,47 +1939,47 @@
 !
 !--    Allocate Obukhov length and bulk Richardson number. Actually, at
-!--    vertical surfaces these are only required for natural surfaces.  
+!--    vertical surfaces these are only required for natural surfaces.
 !--    for natural land surfaces
-       ALLOCATE( surfaces%ol(1:surfaces%ns)  ) 
-       ALLOCATE( surfaces%rib(1:surfaces%ns) ) 
-!
-!--    Allocate arrays for surface momentum fluxes for u and v. For u at north- 
+       ALLOCATE( surfaces%ol(1:surfaces%ns)  )
+       ALLOCATE( surfaces%rib(1:surfaces%ns) )
+!
+!--    Allocate arrays for surface momentum fluxes for u and v. For u at north-
 !--    and south-facing surfaces, for v at east- and west-facing surfaces.
        ALLOCATE ( surfaces%mom_flux_uv(1:surfaces%ns) )
 !
 !--    Allocate array for surface momentum flux for w - wsus and wsvs
-       ALLOCATE ( surfaces%mom_flux_w(1:surfaces%ns) ) 
-!
-!--    Allocate array for surface momentum flux for subgrid-scale tke wsus and 
+       ALLOCATE ( surfaces%mom_flux_w(1:surfaces%ns) )
+!
+!--    Allocate array for surface momentum flux for subgrid-scale tke wsus and
 !--    wsvs; first index usvs or vsws, second index for wsus or wsvs, depending
 !--    on surface.
-       ALLOCATE ( surfaces%mom_flux_tke(0:1,1:surfaces%ns) )  
+       ALLOCATE ( surfaces%mom_flux_tke(0:1,1:surfaces%ns) )
 !
 !--    Characteristic temperature and surface flux of sensible heat
-       ALLOCATE ( surfaces%ts(1:surfaces%ns)  )    
+       ALLOCATE ( surfaces%ts(1:surfaces%ns)  )
        ALLOCATE ( surfaces%shf(1:surfaces%ns) )
 !
 !--    surface temperature
-       ALLOCATE ( surfaces%pt_surface(1:surfaces%ns) ) 
+       ALLOCATE ( surfaces%pt_surface(1:surfaces%ns) )
 !
 !--    Characteristic humidity and surface flux of latent heat
        IF ( humidity )  THEN
-          ALLOCATE ( surfaces%qs(1:surfaces%ns)          ) 
-          ALLOCATE ( surfaces%qsws(1:surfaces%ns)        )   
+          ALLOCATE ( surfaces%qs(1:surfaces%ns)          )
+          ALLOCATE ( surfaces%qsws(1:surfaces%ns)        )
           ALLOCATE ( surfaces%q_surface(1:surfaces%ns)   )
-          ALLOCATE ( surfaces%vpt_surface(1:surfaces%ns) )            
-       ENDIF 
+          ALLOCATE ( surfaces%vpt_surface(1:surfaces%ns) )
+       ENDIF
 !
 !--    Characteristic scalar and surface flux of scalar
        IF ( passive_scalar )  THEN
-          ALLOCATE ( surfaces%ss(1:surfaces%ns)   )   
-          ALLOCATE ( surfaces%ssws(1:surfaces%ns) ) 
+          ALLOCATE ( surfaces%ss(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%ssws(1:surfaces%ns) )
        ENDIF
 !
 !--    Scaling parameter (cs*) and surface flux of chemical species
        IF ( air_chemistry )  THEN
-             ALLOCATE ( surfaces%css(1:nvar,1:surfaces%ns)   )   
-             ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) ) 
-       ENDIF 
+             ALLOCATE ( surfaces%css(1:nvar,1:surfaces%ns)   )
+             ALLOCATE ( surfaces%cssws(1:nvar,1:surfaces%ns) )
+       ENDIF
 !
 !--    Arrays for storing potential temperature and
@@ -1954,4 +2002,11 @@
           ALLOCATE ( surfaces%nrsws(1:surfaces%ns) )
        ENDIF
+
+       IF ( surf_bulk_cloud_model .AND. surf_microphysics_ice_extension)  THEN
+          ALLOCATE ( surfaces%qis(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%nis(1:surfaces%ns)   )
+          ALLOCATE ( surfaces%qisws(1:surfaces%ns) )
+          ALLOCATE ( surfaces%nisws(1:surfaces%ns) )
+       ENDIF
 !
 !--    Salinity surface flux
@@ -1964,5 +2019,5 @@
 ! Description:
 ! ------------
-!> Exit memory for vertical surface types. 
+!> Exit memory for vertical surface types.
 !------------------------------------------------------------------------------!
 #if defined( _OPENACC )
@@ -1996,13 +2051,13 @@
 ! Description:
 ! ------------
-!> Enter memory for vertical surface types. 
+!> Enter memory for vertical surface types.
 !------------------------------------------------------------------------------!
 #if defined( _OPENACC )
     SUBROUTINE enter_surface_attributes_v( surfaces )
-   
+
        IMPLICIT NONE
-   
+
        TYPE(surf_type) ::  surfaces  !< respective surface type
-   
+
        !$ACC ENTER DATA &
        !$ACC COPYIN(surfaces%start_index(nys:nyn,nxl:nxr)) &
@@ -2021,5 +2076,5 @@
        !$ACC COPYIN(surfaces%pt1(1:surfaces%ns)) &
        !$ACC COPYIN(surfaces%qv1(1:surfaces%ns))
-   
+
     END SUBROUTINE enter_surface_attributes_v
 #endif
@@ -2028,10 +2083,10 @@
 ! Description:
 ! ------------
-!> Initialize surface elements, i.e. set initial values for surface fluxes, 
-!> friction velocity, calcuation of start/end indices, etc. . 
-!> Please note, further initialization concerning 
-!> special surface characteristics, e.g. soil- and vegatation type, 
-!> building type, etc., is done in the land-surface and urban-surface module, 
-!> respectively.  
+!> Initialize surface elements, i.e. set initial values for surface fluxes,
+!> friction velocity, calcuation of start/end indices, etc. .
+!> Please note, further initialization concerning
+!> special surface characteristics, e.g. soil- and vegatation type,
+!> building type, etc., is done in the land-surface and urban-surface module,
+!> respectively.
 !------------------------------------------------------------------------------!
     SUBROUTINE init_surfaces
@@ -2054,5 +2109,5 @@
        INTEGER(iwp), DIMENSION(0:2) ::  num_def_h_kji !< dummy to determing local end index in surface type for given (j,i), for horizonal default surfaces
        INTEGER(iwp), DIMENSION(0:2) ::  start_index_def_h !< dummy to determing local start index in surface type for given (j,i), for horizontal default surfaces
-     
+
        INTEGER(iwp), DIMENSION(0:3) ::  num_def_v     !< current number of vertical surface element, default type
        INTEGER(iwp), DIMENSION(0:3) ::  num_def_v_kji !< dummy to determing local end index in surface type for given (j,i), for vertical default surfaces
@@ -2068,7 +2123,7 @@
        LOGICAL ::  building            !< flag indicating building grid point
        LOGICAL ::  terrain             !< flag indicating natural terrain grid point
-       LOGICAL ::  unresolved_building !< flag indicating a grid point where actually a building is defined but not resolved by the vertical grid 
-!
-!--    Set offset indices, i.e. index difference between surface element and 
+       LOGICAL ::  unresolved_building !< flag indicating a grid point where actually a building is defined but not resolved by the vertical grid
+!
+!--    Set offset indices, i.e. index difference between surface element and
 !--    surface-bounded grid point.
 !--    Upward facing - no horizontal offsets
@@ -2127,5 +2182,5 @@
 
 !
-!--    Initialize surface attributes, store indicies, surfaces orientation, etc., 
+!--    Initialize surface attributes, store indicies, surfaces orientation, etc.,
        num_def_h(0:2) = 1
        num_def_v(0:3) = 1
